#include "iodefine.h"
#include <stdarg.h>
#include <stdio.h>


#define BUFF_SIZE	512

static char sci1_buff[BUFF_SIZE];
static int sci1_length;
static int sci1_point;

static char sci9_buff[BUFF_SIZE];
static int sci9_length;
static int sci9_point;

//vOR[h13.23
int SCI1_SEND_CHECK(void){
	if(SCI1.SSR.BIT.TEND == 0) 
	{
		return 1;//f[^M
	}else{
		return 0;//f[^M҂
	}
}

//vOR[h13.22
int SCI1_PRINTF(const char *format, ...)
{
	va_list arg;
	
	if(SCI1.SSR.BIT.TEND == 0) return -1;//0Ȃ΁ALN^𑗐M
	
	va_start(arg, format);
	sci1_length = vsprintf(sci1_buff, format, arg);
	va_end(arg);

	if(sci1_length < 1) return -1;//M镶0܂́AωłȂꍇ
	sci1_point=0;
	
	SCI1.SCR.BIT.TE		= 1;//VAM싖
	SCI1.SCR.BIT.TIE	= 1;//TXI荞ݗv
	SCI1.TDR = sci1_buff[sci1_point++];

	
	return 0;
}

//荞
//vOR[h13.24
void int_sci1_txi(void)
{
	if( sci1_point  == sci1_length) {
		SCI1.SCR.BIT.TIE = 0;
		SCI1.SCR.BIT.TEIE = 1;
	}else{
		SCI1.TDR = sci1_buff[sci1_point++];
	}

}

//荞
//vOR[h13.25
void int_sci1_tei(void)
{
	SCI1.SCR.BIT.TE = 0;
	SCI1.SCR.BIT.TIE = 0;
	SCI1.SCR.BIT.TEIE = 0;
}


//vOR[h13.21
void SCI1_INIT(void)
{
	SYSTEM.PRCR.WORD = 0xA502;
	MSTP(SCI1) = 0;
	SYSTEM.PRCR.WORD = 0xA500;

	SCI1.SCR.BYTE = 0x00;
	while (0x00 != (SCI1.SCR.BYTE & 0xF0));//삪~܂ő҂
	
	PORT2.PODR.BIT.B6 = 1;//o͂1ɂ
	PORT2.PDR.BIT.B6 = 1;//o͂ɐݒ
	PORT3.PDR.BIT.B0 = 0;//͂ɐݒ
	PORT2.PMR.BIT.B6 = 0;//ėp|[gɐݒ
	PORT3.PMR.BIT.B0 = 0;//ėp|[gɐݒ

	MPC.PWPR.BIT.B0WI  = 0;
	MPC.PWPR.BIT.PFSWE = 1;
	MPC.P26PFS.BIT.PSEL = 0x0A;//TXD1
	MPC.P30PFS.BIT.PSEL = 0x0A;//RXD1
	MPC.PWPR.BIT.PFSWE = 0;
	MPC.PWPR.BIT.B0WI  = 1;

	SCI1.SCR.BIT.CKE = 0;
	
	SCI1.SMR.BYTE = 0x00;//1stopbit parityȂ@8bit 
	SCI1.SCMR.BYTE = 0xF2;//VAR~jP[VC^[tF[XAf[^̔]Ȃ
	
	SCI1.SEMR.BYTE = 0x10;//8TCN
	
	SCI1.BRR =25; //@48MHz 115200bps
	
	PORT2.PMR.BIT.B6	= 1;//Ӌ@\(TXD1)ƂĎgp
	PORT3.PMR.BIT.B0	= 1;//Ӌ@\(RXD1)ƂĎgp	
	IPR(SCI1, TXI1) 	= 1;//荞݃x̐ݒ 
	IPR(SCI1, TEI1) 	= 1;//荞݃x̐ݒ 
	IR(SCI1, TEI1) 		= 0;
	IR(SCI1, TXI1) 		= 0;
	IEN(SCI1, TXI1) 	= 1;
	IEN(SCI1, TEI1) 	= 1;

}


///////////////////////////////////////////////////////////////////////////////
// SCI9
///////////////////////////////////////////////////////////////////////////////
int SCI9_SEND_CHECK(void){
	if(SCI9.SSR.BIT.TEND == 0) 
	{
		return 1;//f[^M
	}else{
		return 0;//f[^M҂
	}
}

int SCI9_PRINTF(const char *format, ...)
{
	va_list arg;
	
	if(SCI9.SSR.BIT.TEND == 0) return -1;//0Ȃ΁ALN^𑗐M
	
	va_start(arg, format);
	sci9_length = vsprintf(sci9_buff, format, arg);
	va_end(arg);

	if(sci9_length < 1) return -1;//M镶0܂́AωłȂꍇ
	sci9_point=0;
	
	SCI9.SCR.BIT.TE		= 1;//VAM싖
	SCI9.SCR.BIT.TIE	= 1;//TXI荞ݗv
	SCI9.TDR = sci9_buff[sci9_point++];

	return 0;
}


//荞
void int_sci9_txi(void)
{

	if( sci9_point  == sci9_length) {
		SCI9.SCR.BIT.TIE = 0;
		SCI9.SCR.BIT.TEIE = 1;
	}else{
		SCI9.TDR = sci9_buff[sci9_point++];
	}	
}

//荞
void int_sci9_tei(void)
{
	SCI9.SCR.BIT.TE = 0;
	SCI9.SCR.BIT.TIE = 0;
	SCI9.SCR.BIT.TEIE = 0;
}


void SCI9_INIT(void)
{
	SYSTEM.PRCR.WORD = 0xA502;
	MSTP(SCI9) = 0;
	SYSTEM.PRCR.WORD = 0xA500;

	SCI9.SCR.BYTE = 0x00;
	while (0x00 != (SCI9.SCR.BYTE & 0xF0));//삪~܂ő҂
	
	PORTB.PODR.BIT.B7 = 1;//o͂1ɂ
	PORTB.PDR.BIT.B7 = 1;//o͂ɐݒ
	PORTB.PDR.BIT.B6 = 0;//͂ɐݒ
	PORTB.PMR.BIT.B7 = 0;//ėp|[gɐݒ
	PORTB.PMR.BIT.B6 = 0;//ėp|[gɐݒ

	MPC.PWPR.BIT.B0WI  = 0;
	MPC.PWPR.BIT.PFSWE = 1;
	MPC.PB7PFS.BIT.PSEL = 0x0A;//TXD9
	MPC.PB6PFS.BIT.PSEL = 0x0A;//RXD9
	MPC.PWPR.BIT.PFSWE = 0;
	MPC.PWPR.BIT.B0WI  = 1;

	SCI9.SCR.BIT.CKE = 0;
	
	SCI9.SMR.BYTE = 0x00;//1stopbit parityȂ@8bit 
	SCI9.SCMR.BYTE = 0xF2;//VAR~jP[VC^[tF[XAf[^̔]Ȃ
	
	SCI9.SEMR.BYTE = 0x10;//8TCN
	
	SCI9.BRR =25; //@48MHz 115200bps

	PORTB.PMR.BIT.B7	= 1;//Ӌ@\(TXD9)ƂĎgp
	PORTB.PMR.BIT.B6	= 1;//Ӌ@\(RXD9)ƂĎgp
	IPR(SCI9, TXI9) 	= 1;//荞݃x̐ݒ 
	IPR(SCI9, TEI9) 	= 1;//荞݃x̐ݒ 
	IR(SCI9, TEI9) 		= 0;
	IR(SCI9, TXI9) 		= 0;
	IEN(SCI9, TXI9) 	= 1;
	IEN(SCI9, TEI9) 	= 1;
	
}